#include <stdlib.h>
#include <stdbool.h>
#include "list.h"

/* Init the values */
void init_node(node* n) {
    n->data = NULL;
    n->next = NULL;
    n->prev = NULL;
} 

/* Init list data structure */
void init_list(list* l) {
    l->begin = NULL;
    l->end = NULL;
}
 
/* Functions for manipulating our auxiliary list */

/* Add node to the end of the list l and fill it with data */
void list_add_node_end(list *l, void* data) {
    node* newNode;
    
    newNode = (node*) malloc(sizeof(node));
    init_node(newNode);

    newNode->data = data;
    newNode->prev = l->end;
    if (l->end != NULL) 
        l->end->next = newNode;
    else 
        l->begin = newNode;
    l->end = newNode;            
}

/* Add node to the beginning of the list l and fill it with data */
void list_add_node_begin(list *l, void* data) {
    node* newNode;
    
    newNode = (node*) malloc(sizeof(node));
    init_node(newNode);

    newNode->data = data;
    newNode->next = l->begin;
    if (l->begin != NULL) 
        l->begin->prev = newNode ;
    else 
        l->end = newNode;
    l->begin = newNode;  
}

/* Remove the node from the list l */
void list_remove_node(list* l, node* rnode) {
    node* pNode;
    
    pNode = l->begin;

    while (pNode != NULL) {
        if (pNode == rnode) {
            if (pNode->prev != NULL) pNode->prev->next = pNode->next;
            if (pNode->next != NULL) pNode->next->prev = pNode->prev;

            if (l->begin == pNode) {
                l->begin = l->begin->next;
                if (l->begin != NULL) l->begin->prev = NULL;
            }    
            if (l->end == pNode) {
                l->end = l->end->prev;
                if (l->end != NULL) l->end->next = NULL;
            }   
            free(rnode);
            break; 
        }

        pNode = pNode->next;
    }
}

void list_release(list *l) {
    node* pNode;
    
    pNode = l->begin;
    while (pNode != NULL) {
        l->begin = pNode->next;
        free(pNode);
        pNode = l->begin;
    }
    l->begin = NULL;
    l->end = NULL;
}

