/* PB164 Generic List Example, header file
 * Vasek Lorenc, 2010
 */
#ifndef __LIST_H__
#define __LIST_H__

/* This is how a node looks like today */
typedef struct _node {
    void*   data;    
    struct _node*  next;
    struct _node*  prev;
} node;

/* Auxiliary list structure */
typedef struct _list {
    node*   begin;
    node*   end;
} list;

/* Prototypes for list manipulation functions */
void init_list(list* l);
void init_node(node* n);

/* Do not forget that `data' is completely managed by you, programmer! Not only
 * that you have to allocate/release the memory for it, but if you want to
 * manipulate/retrieve the data, you are supposed to force the correct data
 * type in your code!
 */
void list_add_node_end(list *l, void* data);
void list_add_node_begin(list *l, void* data);
void list_remove_node(list* l, node* remNode);
void list_release(list *l);

#endif
